/** board_data.h
 *
 *  Author: J. Krauth
 *  Creation: 23.09.2015
 *  $LastChangedDate: 2015-01-12 17:26:28 +0100 (Mo, 12. Jan 2015) $
 *  $LastChangedRevision: 1381 $
 *
 *  Copyright (C) 2015 ADDI-DATA GmbH
 *
 *  ADDI-DATA GmbH
 *  Airpark Business Center
 *  Airport Boulevard B210
 *  77836 Rheinmünster
 *  Germany
 *  Tel: +49(0)7229/1847-0    |  Fax: +49(0)7229/1847-200
 *  http://www.addi-data-com  |  info@addi-data.com
 **/

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

#ifndef __PCIE040_BOARD_DATA_H__
#define __PCIE040_BOARD_DATA_H__

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

#define MODULE_NAME "pcie040"

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

#include <linux/module.h>

#ifdef CONFIG_XENOMAI
	#include <rtdm/driver.h>
#endif

#include "pcie040-kapi.h"

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

typedef struct pcie040BoardData_s
{
    unsigned int id;

    void *bar0;

    unsigned int irqRequested;
    pcie040_irqCallback irqCallback;

#ifdef CONFIG_XENOMAI
    rtdm_irq_t irqHandle;
    struct pci_dev *pdev;
#endif
    struct fasync_struct *asyncQueue;

    uint32_t interruptSource;
    uint32_t interruptMask;
    uint32_t latchedValue;

    struct pci_dev *prevBoard;
    struct pci_dev *nextBoard;
} pcie040BoardData_t;

static __inline__ pcie040BoardData_t* PCIE040_PRIVDATA(struct pci_dev *pdev)
{
#ifdef CONFIG_XENOMAI
	struct rtdm_device *rtdmdev = (struct rtdm_device *) pci_get_drvdata (pdev);
	return (pcie040BoardData_t *) rtdmdev->device_data;
#else
	return (pcie040BoardData_t *) pci_get_drvdata (pdev);
#endif
}

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

#endif // __PCIE040_BOARD_DATA_H__
