/** pci040-kapi.h
 *
 *  Author: J. Krauth
 *  Creation: 23.09.2015
 *  $LastChangedDate: 2015-01-12 17:04:29 +0100 (Mo, 12. Jan 2015) $
 *  $LastChangedRevision: 1379 $
 *
 *  Copyright (C) 2015 ADDI-DATA GmbH
 *
 *  ADDI-DATA GmbH
 *  Airpark Business Center
 *  Airport Boulevard B210
 *  77836 Rheinmünster
 *  Germany
 *  Tel: +49(0)7229/1847-0    |  Fax: +49(0)7229/1847-200
 *  http://www.addi-data-com  |  info@addi-data.com
 **/

#ifndef __PCIE040_PRIVATE_H__
#define __PCIE040_PRIVATE_H__

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

#include <linux/pci.h>

//--------------------------------------------------------------------------------------
// Interrupt
//--------------------------------------------------------------------------------------

void v_PCIE040_DispatchInterrupt(struct pci_dev *pdev, uint32_t interruptSource, uint32_t interruptMask, uint32_t *value, uint32_t count);

//--------------------------------------------------------------------------------------
// IOCTL
//--------------------------------------------------------------------------------------

#ifdef CONFIG_XENOMAI
	int pcie040_open_rt (struct rtdm_fd *fd, int oflags);
	void pcie040_close_rt (struct rtdm_fd *fd);
	int pcie040_ioctl_rt (struct rtdm_fd *fd, unsigned int request, void *arg);
#endif

#ifdef CONFIG_XENOMAI
	#define print(format, arg...) rtdm_printk(format, ## arg)
#else
	#define print(format, arg...) printk(format, ## arg)
#endif

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

#endif // __PCIE040_PRIVATE_H__
