/** common.h
 *
 *  Author: J. Krauth
 *  Creation: 23.09.2015
 *  $LastChangedDate: 2015-01-13 10:48:53 +0100 (Di, 13. Jan 2015) $
 *  $LastChangedRevision: 1385 $
 *
 *  Copyright (C) 2015 ADDI-DATA GmbH
 *
 *  ADDI-DATA GmbH
 *  Airpark Business Center
 *  Airport Boulevard B210
 *  77836 Rheinmünster
 *  Germany
 *  Tel: +49(0)7229/1847-0    |  Fax: +49(0)7229/1847-200
 *  http://www.addi-data-com  |  info@addi-data.com
 **/

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

#ifndef __COMMON_H__
#define __COMMON_H__

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

#include <fcntl.h>
#include <inttypes.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <sys/ioctl.h>
#include "../driver/pcie040-ioctl.h"

/** \defgroup PCIE040_USER_MODE_API xPCIe-040 user mode API
 * @{
 */
/* @} */

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

/** \addtogroup General xPCIe-040 general functions
* \ingroup PCIE040_USER_MODE_API
 * @{
 *
 */

/** Get the board device structure.
 *
 * @param[in] id                       : Minor number of the device to manage \n
 *
 * @return    >0 : Pointer on the device structure\n
 *             0 : Error \n
 */
int i_PCIE040_GetBoardFileDescriptor(uint8_t boardId);

/* @} */

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

#endif // __COMMON_H__
