/** temperature.c
 *
 *  Author: J. Krauth
 *  Creation: 23.09.2015
 *  $LastChangedDate: 2015-01-13 10:48:53 +0100 (Di, 13. Jan 2015) $
 *  $LastChangedRevision: 1385 $
 *
 *  Copyright (C) 2015 ADDI-DATA GmbH
 *
 *  ADDI-DATA GmbH
 *  Airpark Business Center
 *  Airport Boulevard B210
 *  77836 Rheinmünster
 *  Germany
 *  Tel: +49(0)7229/1847-0    |  Fax: +49(0)7229/1847-200
 *  http://www.addi-data-com  |  info@addi-data.com
 **/

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

#include "common.h"

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

int i_PCIE040_TemperatureTestConversion (uint8_t boardId,
                                          uint8_t *eoc)
{
	PCIE040_TemperatureTestConversion_t params;

	int ret = ioctl(i_PCIE040_GetBoardFileDescriptor(boardId), PCIE040_TEMPERATURE_TEST_CONVERSION, &params);

    if (ret == 0)
        *eoc = params.eoc;
    else
    	*eoc = 0;

    return ret;
}

//--------------------------------------------------------------------------------------

int i_PCIE040_TemperatureReadValue (uint8_t boardId,
                                     int32_t *value)
{
	PCIE040_TemperatureReadValue_t params;

    int ret = ioctl(i_PCIE040_GetBoardFileDescriptor(boardId), PCIE040_TEMPERATURE_READ_VALUE, &params);

    if (ret == 0)
        *value = params.value;
    else
    	*value = 0;

    return ret;
}

//--------------------------------------------------------------------------------------

int i_PCIE040_TemperatureWarningInit (uint8_t boardId,
                                       int32_t value)
{
	int ret = 0;

	PCIE040_TemperatureWarningInit_t params =
    {
        .value = value
    };

	ret = ioctl(i_PCIE040_GetBoardFileDescriptor(boardId), PCIE040_TEMPERATURE_WARNING_INIT, &params);

	return (ret);
}

//--------------------------------------------------------------------------------------

int i_PCIE040_TemperatureWarningStartStop (uint8_t boardId,
                                            uint8_t cmd)
{
	int ret = 0;

	PCIE040_TemperatureWarningStartStop_t params =
    {
        .cmd = cmd
    };

	ret = ioctl(i_PCIE040_GetBoardFileDescriptor(boardId), PCIE040_TEMPERATURE_WARNING_START_STOP, &params);

	return (ret);
}

//--------------------------------------------------------------------------------------
//--------------------------------------------------------------------------------------

